// $ANTLR 2.7.7 (2006-11-01): "xpath.g" -> "XPathRecognizer.java"$

	package com.werken.xpath.parser;

	import com.werken.xpath.XPath;
	import com.werken.xpath.impl.*;

	import java.util.List;
	import java.util.ArrayList;
	import java.util.Collections;
	
	/** Generated by <a href="http://www.antlr.org/">antlr parser-generator</a> */

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

public class XPathRecognizer extends antlr.LLkParser       implements XPathTokenTypes
 {

		private Expr makeBinaryExpr(Op op, Expr lhs, Expr rhs)
		{
			if ( op == null ) {
				return lhs;
			}

			return new BinaryExpr(op, lhs, rhs);
		}
	
protected XPathRecognizer(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public XPathRecognizer(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected XPathRecognizer(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public XPathRecognizer(TokenStream lexer) {
  this(lexer,2);
}

public XPathRecognizer(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
}

	public final Expr  xpath() throws RecognitionException, TokenStreamException {
		Expr expr;
		
		
				expr = null;
			
		
		try {      // for error handling
			expr=union_expr();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_0);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final Expr  union_expr() throws RecognitionException, TokenStreamException {
		Expr expr;
		
		
				expr = null;
		
				Expr lhs = null;
				Expr rhs = null;
				Op op = null;
			
		
		try {      // for error handling
			lhs=path_expr();
			{
			_loop49:
			do {
				if ((LA(1)==PIPE)) {
					match(PIPE);
					if ( inputState.guessing==0 ) {
						op=Op.UNION;
					}
					rhs=path_expr();
				}
				else {
					break _loop49;
				}
				
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				
							expr = makeBinaryExpr(op, lhs, rhs);
						
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final LocationPath  location_path() throws RecognitionException, TokenStreamException {
		LocationPath path;
		
		
				path = null;
			
		
		try {      // for error handling
			switch ( LA(1)) {
			case SLASH:
			case DOUBLE_SLASH:
			{
				path=absolute_location_path();
				break;
			}
			case AT:
			case STAR:
			case IDENTIFIER:
			case DOT:
			case DOT_DOT:
			{
				path=relative_location_path();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_2);
			} else {
			  throw ex;
			}
		}
		return path;
	}
	
	public final LocationPath  absolute_location_path() throws RecognitionException, TokenStreamException {
		LocationPath path;
		
		
				path = new LocationPath();
			
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case SLASH:
			{
				match(SLASH);
				break;
			}
			case DOUBLE_SLASH:
			{
				match(DOUBLE_SLASH);
				if ( inputState.guessing==0 ) {
					
									path.addStep( new NodeTypeStep("descendant-or-self", "node") );
								
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			boolean synPredMatched7 = false;
			if (((_tokenSet_3.member(LA(1))) && (_tokenSet_4.member(LA(2))))) {
				int _m7 = mark();
				synPredMatched7 = true;
				inputState.guessing++;
				try {
					{
					switch ( LA(1)) {
					case AT:
					{
						match(AT);
						break;
					}
					case STAR:
					{
						match(STAR);
						break;
					}
					case IDENTIFIER:
					{
						match(IDENTIFIER);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
				}
				catch (RecognitionException pe) {
					synPredMatched7 = false;
				}
				rewind(_m7);
inputState.guessing--;
			}
			if ( synPredMatched7 ) {
				path=i_relative_location_path(path);
			}
			else if ((_tokenSet_2.member(LA(1))) && (_tokenSet_5.member(LA(2)))) {
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			if ( inputState.guessing==0 ) {
				
							path.setIsAbsolute(true);
						
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_2);
			} else {
			  throw ex;
			}
		}
		return path;
	}
	
	public final LocationPath  relative_location_path() throws RecognitionException, TokenStreamException {
		LocationPath path;
		
		
				path = null;
			
		
		try {      // for error handling
			path=i_relative_location_path(path);
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_2);
			} else {
			  throw ex;
			}
		}
		return path;
	}
	
	public final LocationPath  i_relative_location_path(
		LocationPath in_path
	) throws RecognitionException, TokenStreamException {
		LocationPath path;
		
		
				if (in_path == null) {
					path = new LocationPath();
				} else {
					path = in_path;
				}
		
				Step step = null;
			
		
		try {      // for error handling
			step=step();
			if ( inputState.guessing==0 ) {
				
							path.addStep(step);
						
			}
			{
			_loop12:
			do {
				if ((LA(1)==SLASH||LA(1)==DOUBLE_SLASH)) {
					{
					switch ( LA(1)) {
					case SLASH:
					{
						match(SLASH);
						break;
					}
					case DOUBLE_SLASH:
					{
						match(DOUBLE_SLASH);
						if ( inputState.guessing==0 ) {
							
												path.addStep( new NodeTypeStep("descendant-or-self", "node") );
											
						}
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					step=step();
					if ( inputState.guessing==0 ) {
						
											path.addStep(step);
										
					}
				}
				else {
					break _loop12;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_2);
			} else {
			  throw ex;
			}
		}
		return path;
	}
	
	public final Step  step() throws RecognitionException, TokenStreamException {
		Step step;
		
		Token  ns = null;
		Token  id = null;
		
			    step             = null;
				String axis      = "child";
				String localName = null;
				String prefix    = null;
				String nodeType  = null;
				Predicate pred   = null;
			
		
		try {      // for error handling
			switch ( LA(1)) {
			case AT:
			case STAR:
			case IDENTIFIER:
			{
				{
				{
				boolean synPredMatched17 = false;
				if (((LA(1)==AT||LA(1)==IDENTIFIER) && ((LA(2) >= STAR && LA(2) <= DOUBLE_COLON)))) {
					int _m17 = mark();
					synPredMatched17 = true;
					inputState.guessing++;
					try {
						{
						switch ( LA(1)) {
						case IDENTIFIER:
						{
							match(IDENTIFIER);
							match(DOUBLE_COLON);
							break;
						}
						case AT:
						{
							match(AT);
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
					}
					catch (RecognitionException pe) {
						synPredMatched17 = false;
					}
					rewind(_m17);
inputState.guessing--;
				}
				if ( synPredMatched17 ) {
					axis=axis();
				}
				else if ((LA(1)==STAR||LA(1)==IDENTIFIER) && (_tokenSet_6.member(LA(2)))) {
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
				{
				if ((LA(1)==STAR||LA(1)==IDENTIFIER) && (_tokenSet_7.member(LA(2)))) {
					{
					{
					{
					if ((LA(1)==IDENTIFIER) && (LA(2)==COLON)) {
						ns = LT(1);
						match(IDENTIFIER);
						match(COLON);
						if ( inputState.guessing==0 ) {
							
															prefix = ns.getText();
														
						}
					}
					else if ((LA(1)==STAR||LA(1)==IDENTIFIER) && (_tokenSet_8.member(LA(2)))) {
					}
					else {
						throw new NoViableAltException(LT(1), getFilename());
					}
					
					}
					{
					switch ( LA(1)) {
					case IDENTIFIER:
					{
						id = LT(1);
						match(IDENTIFIER);
						if ( inputState.guessing==0 ) {
							
																localName = id.getText();
															
						}
						break;
					}
					case STAR:
					{
						match(STAR);
						if ( inputState.guessing==0 ) {
							
																localName = "*";
															
						}
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					}
					if ( inputState.guessing==0 ) {
						
												step = new NameTestStep(axis, prefix, localName);
											
					}
					}
				}
				else if ((LA(1)==IDENTIFIER) && (LA(2)==LEFT_PAREN)) {
					step=special_step(axis);
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
				{
				_loop24:
				do {
					if ((LA(1)==LEFT_BRACKET)) {
						pred=predicate();
						if ( inputState.guessing==0 ) {
							
												((UnAbbrStep)step).addPredicate(pred);
											
						}
					}
					else {
						break _loop24;
					}
					
				} while (true);
				}
				}
				break;
			}
			case DOT:
			case DOT_DOT:
			{
				step=abbr_step();
				{
				_loop26:
				do {
					if ((LA(1)==LEFT_BRACKET)) {
						pred=predicate();
						if ( inputState.guessing==0 ) {
							
												((UnAbbrStep)step).addPredicate(pred);
											
						}
					}
					else {
						break _loop26;
					}
					
				} while (true);
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_9);
			} else {
			  throw ex;
			}
		}
		return step;
	}
	
	public final String  axis() throws RecognitionException, TokenStreamException {
		String axisName;
		
		Token  id = null;
		
				axisName = null;
			
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case IDENTIFIER:
			{
				id = LT(1);
				match(IDENTIFIER);
				match(DOUBLE_COLON);
				if ( inputState.guessing==0 ) {
					
									axisName = id.getText();
								
				}
				break;
			}
			case AT:
			{
				match(AT);
				if ( inputState.guessing==0 ) {
					
									axisName = "attribute";
								
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_10);
			} else {
			  throw ex;
			}
		}
		return axisName;
	}
	
	public final Step  special_step(
		String axis
	) throws RecognitionException, TokenStreamException {
		Step step;
		
		Token  target = null;
		Token  nodeType = null;
		
				step = null;
				String piTarget = null;
			
		
		try {      // for error handling
			if (((LA(1)==IDENTIFIER) && (LA(2)==LEFT_PAREN))&&(
		LT(1).getText().equals("processing-instruction")
	)) {
				match(IDENTIFIER);
				match(LEFT_PAREN);
				{
				switch ( LA(1)) {
				case IDENTIFIER:
				{
					target = LT(1);
					match(IDENTIFIER);
					if ( inputState.guessing==0 ) {
						
											piTarget = target.getText();
										
					}
					break;
				}
				case RIGHT_PAREN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(RIGHT_PAREN);
				if ( inputState.guessing==0 ) {
					
								step = new PIStep(axis, piTarget);
							
				}
			}
			else if (((LA(1)==IDENTIFIER) && (LA(2)==LEFT_PAREN))&&(
		LT(1).getText().equals("comment")
			||
		LT(1).getText().equals("text")
			||
		LT(1).getText().equals("node")
	)) {
				nodeType = LT(1);
				match(IDENTIFIER);
				match(LEFT_PAREN);
				match(RIGHT_PAREN);
				if ( inputState.guessing==0 ) {
					
								step = new NodeTypeStep(axis, nodeType.getText());
							
				}
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_8);
			} else {
			  throw ex;
			}
		}
		return step;
	}
	
	public final Predicate  predicate() throws RecognitionException, TokenStreamException {
		Predicate pred;
		
		
				pred = null;
			
		
		try {      // for error handling
			match(LEFT_BRACKET);
			pred=predicate_expr();
			match(RIGHT_BRACKET);
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_8);
			} else {
			  throw ex;
			}
		}
		return pred;
	}
	
	public final Step  abbr_step() throws RecognitionException, TokenStreamException {
		Step step;
		
		
				step = null;
			
		
		try {      // for error handling
			switch ( LA(1)) {
			case DOT:
			{
				match(DOT);
				if ( inputState.guessing==0 ) {
					
									step = new NodeTypeStep("self", "node");
								
				}
				break;
			}
			case DOT_DOT:
			{
				match(DOT_DOT);
				if ( inputState.guessing==0 ) {
					
									step = new ParentStep();
								
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_8);
			} else {
			  throw ex;
			}
		}
		return step;
	}
	
	public final Predicate  predicate_expr() throws RecognitionException, TokenStreamException {
		Predicate pred;
		
		
				pred = null;
				Expr expr = null;
			
		
		try {      // for error handling
			expr=expr();
			if ( inputState.guessing==0 ) {
				
							pred = new Predicate(expr);
						
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_11);
			} else {
			  throw ex;
			}
		}
		return pred;
	}
	
	public final Expr  expr() throws RecognitionException, TokenStreamException {
		Expr expr;
		
		
				expr = null;
			
		
		try {      // for error handling
			expr=or_expr();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_12);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final void abbr_axis_specifier() throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case AT:
			{
				match(AT);
				break;
			}
			case EOF:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_0);
			} else {
			  throw ex;
			}
		}
	}
	
	public final Expr  or_expr() throws RecognitionException, TokenStreamException {
		Expr expr;
		
		
				expr = null;
				Expr lhs = null;
				Expr rhs = null;
				Op op = null;
			
		
		try {      // for error handling
			expr=and_expr();
			{
			_loop64:
			do {
				if ((LA(1)==KW_OR)) {
					match(KW_OR);
					if ( inputState.guessing==0 ) {
						op = Op.OR;
					}
					rhs=and_expr();
					if ( inputState.guessing==0 ) {
						
									expr = makeBinaryExpr(op, expr, rhs);
								
					}
				}
				else {
					break _loop64;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_12);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final Expr  primary_expr() throws RecognitionException, TokenStreamException {
		Expr expr;
		
		
				expr = null;
			
		
		try {      // for error handling
			switch ( LA(1)) {
			case DOLLAR_SIGN:
			{
				expr=variable_reference();
				break;
			}
			case LEFT_PAREN:
			{
				match(LEFT_PAREN);
				expr=expr();
				match(RIGHT_PAREN);
				break;
			}
			case LITERAL:
			{
				expr=literal();
				break;
			}
			case NUMBER:
			{
				expr=number();
				break;
			}
			case IDENTIFIER:
			{
				expr=function_call();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_8);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final VariableExpr  variable_reference() throws RecognitionException, TokenStreamException {
		VariableExpr expr;
		
		Token  id = null;
		
				expr = null;
			
		
		try {      // for error handling
			match(DOLLAR_SIGN);
			id = LT(1);
			match(IDENTIFIER);
			if ( inputState.guessing==0 ) {
				
							expr = new VariableExpr(id.getText());
						
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_8);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final Expr  literal() throws RecognitionException, TokenStreamException {
		Expr expr;
		
		Token  lit = null;
		
				expr = null;
			
		
		try {      // for error handling
			lit = LT(1);
			match(LITERAL);
			if ( inputState.guessing==0 ) {
				
							expr = new StringExpr(lit.getText());
						
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_8);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final Expr  number() throws RecognitionException, TokenStreamException {
		Expr expr;
		
		Token  num = null;
		
				expr = null;
			
		
		try {      // for error handling
			num = LT(1);
			match(NUMBER);
			if ( inputState.guessing==0 ) {
				
							expr = new NumberExpr(num.getText());
						
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_8);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final FunctionExpr  function_call() throws RecognitionException, TokenStreamException {
		FunctionExpr expr;
		
		Token  id = null;
		
				expr      = null;
				List args = null;
			
		
		try {      // for error handling
			id = LT(1);
			match(IDENTIFIER);
			match(LEFT_PAREN);
			{
			switch ( LA(1)) {
			case SLASH:
			case DOUBLE_SLASH:
			case AT:
			case STAR:
			case IDENTIFIER:
			case LEFT_PAREN:
			case DOT:
			case DOT_DOT:
			case LITERAL:
			case NUMBER:
			case DOLLAR_SIGN:
			case MINUS:
			{
				args=arg_list();
				break;
			}
			case RIGHT_PAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(RIGHT_PAREN);
			if ( inputState.guessing==0 ) {
				
							expr = new FunctionExpr(id.getText(), args);
						
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_8);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final List  arg_list() throws RecognitionException, TokenStreamException {
		List args;
		
		
				args = new ArrayList();
				Expr expr = null;
			
		
		try {      // for error handling
			expr=argument();
			if ( inputState.guessing==0 ) {
				
							args.add(expr);
						
			}
			{
			_loop45:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					expr=argument();
					if ( inputState.guessing==0 ) {
						
										args.add(expr);
									
					}
				}
				else {
					break _loop45;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_13);
			} else {
			  throw ex;
			}
		}
		return args;
	}
	
	public final Expr  argument() throws RecognitionException, TokenStreamException {
		Expr expr;
		
		
				expr = null;
			
		
		try {      // for error handling
			expr=expr();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_14);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final PathExpr  path_expr() throws RecognitionException, TokenStreamException {
		PathExpr expr;
		
		
				expr = null;
				LocationPath path = null;
			
		
		try {      // for error handling
			boolean synPredMatched52 = false;
			if ((((_tokenSet_15.member(LA(1))) && (_tokenSet_16.member(LA(2))))&&( 
			LT(1).getText().equals("processing-instruction")
				||
			LT(1).getText().equals("comment")
				||
			LT(1).getText().equals("text")
				||
			LT(1).getText().equals("node")
		))) {
				int _m52 = mark();
				synPredMatched52 = true;
				inputState.guessing++;
				try {
					{
					match(IDENTIFIER);
					match(LEFT_PAREN);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched52 = false;
				}
				rewind(_m52);
inputState.guessing--;
			}
			if ( synPredMatched52 ) {
				expr=location_path();
			}
			else {
				boolean synPredMatched54 = false;
				if (((_tokenSet_17.member(LA(1))) && (_tokenSet_5.member(LA(2))))) {
					int _m54 = mark();
					synPredMatched54 = true;
					inputState.guessing++;
					try {
						{
						match(IDENTIFIER);
						match(LEFT_PAREN);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched54 = false;
					}
					rewind(_m54);
inputState.guessing--;
				}
				if ( synPredMatched54 ) {
					expr=filter_expr();
					{
					switch ( LA(1)) {
					case SLASH:
					case DOUBLE_SLASH:
					{
						path=absolute_location_path();
						if ( inputState.guessing==0 ) {
							
												((FilterExpr)expr).setLocationPath(path);
											
						}
						break;
					}
					case EOF:
					case STAR:
					case RIGHT_PAREN:
					case RIGHT_BRACKET:
					case COMMA:
					case PIPE:
					case KW_OR:
					case KW_AND:
					case EQUALS:
					case NOT_EQUALS:
					case LT:
					case GT:
					case LTE:
					case GTE:
					case PLUS:
					case MINUS:
					case DIV:
					case MOD:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
				}
				else {
					boolean synPredMatched57 = false;
					if (((_tokenSet_15.member(LA(1))) && (_tokenSet_16.member(LA(2))))) {
						int _m57 = mark();
						synPredMatched57 = true;
						inputState.guessing++;
						try {
							{
							switch ( LA(1)) {
							case DOT:
							{
								match(DOT);
								break;
							}
							case DOT_DOT:
							{
								match(DOT_DOT);
								break;
							}
							case SLASH:
							{
								match(SLASH);
								break;
							}
							case DOUBLE_SLASH:
							{
								match(DOUBLE_SLASH);
								break;
							}
							case IDENTIFIER:
							{
								match(IDENTIFIER);
								break;
							}
							case AT:
							{
								match(AT);
								break;
							}
							default:
							{
								throw new NoViableAltException(LT(1), getFilename());
							}
							}
							}
						}
						catch (RecognitionException pe) {
							synPredMatched57 = false;
						}
						rewind(_m57);
inputState.guessing--;
					}
					if ( synPredMatched57 ) {
						expr=location_path();
					}
					else if ((_tokenSet_17.member(LA(1))) && (_tokenSet_5.member(LA(2)))) {
						expr=filter_expr();
						{
						switch ( LA(1)) {
						case SLASH:
						case DOUBLE_SLASH:
						{
							path=absolute_location_path();
							if ( inputState.guessing==0 ) {
								
													((FilterExpr)expr).setLocationPath(path);
												
							}
							break;
						}
						case EOF:
						case STAR:
						case RIGHT_PAREN:
						case RIGHT_BRACKET:
						case COMMA:
						case PIPE:
						case KW_OR:
						case KW_AND:
						case EQUALS:
						case NOT_EQUALS:
						case LT:
						case GT:
						case LTE:
						case GTE:
						case PLUS:
						case MINUS:
						case DIV:
						case MOD:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
					}
					else {
						throw new NoViableAltException(LT(1), getFilename());
					}
					}}
				}
				catch (RecognitionException ex) {
					if (inputState.guessing==0) {
						reportError(ex);
						recover(ex,_tokenSet_2);
					} else {
					  throw ex;
					}
				}
				return expr;
			}
			
	public final  FilterExpr  filter_expr() throws RecognitionException, TokenStreamException {
		 FilterExpr expr ;
		
		
				expr = null;
				Predicate pred = null;
				Expr filterExpr = null;
			
		
		try {      // for error handling
			filterExpr=primary_expr();
			if ( inputState.guessing==0 ) {
				
							expr = new FilterExpr(filterExpr);
						
			}
			{
			_loop61:
			do {
				if ((LA(1)==LEFT_BRACKET)) {
					pred=predicate();
					if ( inputState.guessing==0 ) {
						
										expr.addPredicate(pred);
									
					}
				}
				else {
					break _loop61;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_9);
			} else {
			  throw ex;
			}
		}
		return expr ;
	}
	
	public final Expr  and_expr() throws RecognitionException, TokenStreamException {
		Expr expr;
		
		
				expr = null;
				Expr lhs = null;
				Expr rhs = null;
				Op op = null;
			
		
		try {      // for error handling
			lhs=equality_expr();
			{
			switch ( LA(1)) {
			case KW_AND:
			{
				match(KW_AND);
				if ( inputState.guessing==0 ) {
					op = Op.AND;
				}
				rhs=equality_expr();
				break;
			}
			case RIGHT_PAREN:
			case RIGHT_BRACKET:
			case COMMA:
			case KW_OR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				
							expr = makeBinaryExpr(op, lhs, rhs);
						
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_18);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final Expr  equality_expr() throws RecognitionException, TokenStreamException {
		Expr expr;
		
		
				expr = null;
				Expr lhs = null;
				Expr rhs = null;
				Op op = null;
			
		
		try {      // for error handling
			lhs=relational_expr();
			{
			switch ( LA(1)) {
			case EQUALS:
			case NOT_EQUALS:
			{
				{
				switch ( LA(1)) {
				case EQUALS:
				{
					match(EQUALS);
					if ( inputState.guessing==0 ) {
						op = Op.EQUAL;
					}
					break;
				}
				case NOT_EQUALS:
				{
					match(NOT_EQUALS);
					if ( inputState.guessing==0 ) {
						op = Op.NOT_EQUAL;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				rhs=relational_expr();
				break;
			}
			case RIGHT_PAREN:
			case RIGHT_BRACKET:
			case COMMA:
			case KW_OR:
			case KW_AND:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				
							expr = makeBinaryExpr(op, lhs, rhs);
						
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_19);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final Expr  relational_expr() throws RecognitionException, TokenStreamException {
		Expr expr;
		
		
				expr = null;
				Expr lhs = null;
				Expr rhs = null;
				Op op = null;
		
			
		
		try {      // for error handling
			lhs=additive_expr();
			{
			switch ( LA(1)) {
			case LT:
			case GT:
			case LTE:
			case GTE:
			{
				{
				switch ( LA(1)) {
				case LT:
				{
					match(LT);
					if ( inputState.guessing==0 ) {
						op = Op.LT;
					}
					break;
				}
				case GT:
				{
					match(GT);
					if ( inputState.guessing==0 ) {
						op = Op.GT;
					}
					break;
				}
				case LTE:
				{
					match(LTE);
					if ( inputState.guessing==0 ) {
						op = Op.LT_EQUAL;
					}
					break;
				}
				case GTE:
				{
					match(GTE);
					if ( inputState.guessing==0 ) {
						op = Op.GT_EQUAL;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				rhs=additive_expr();
				break;
			}
			case RIGHT_PAREN:
			case RIGHT_BRACKET:
			case COMMA:
			case KW_OR:
			case KW_AND:
			case EQUALS:
			case NOT_EQUALS:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				
							expr = makeBinaryExpr(op, lhs, rhs);
						
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final Expr  additive_expr() throws RecognitionException, TokenStreamException {
		Expr expr;
		
		
				expr = null;
				Expr lhs = null;
				Expr rhs = null;
				Op op = null;
			
		
		try {      // for error handling
			lhs=mult_expr();
			{
			switch ( LA(1)) {
			case PLUS:
			case MINUS:
			{
				{
				switch ( LA(1)) {
				case PLUS:
				{
					match(PLUS);
					if ( inputState.guessing==0 ) {
						op = Op.PLUS;
					}
					break;
				}
				case MINUS:
				{
					match(MINUS);
					if ( inputState.guessing==0 ) {
						op = Op.MINUS;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				rhs=mult_expr();
				break;
			}
			case RIGHT_PAREN:
			case RIGHT_BRACKET:
			case COMMA:
			case KW_OR:
			case KW_AND:
			case EQUALS:
			case NOT_EQUALS:
			case LT:
			case GT:
			case LTE:
			case GTE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				
							expr = makeBinaryExpr(op, lhs, rhs);
						
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_21);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final Expr  mult_expr() throws RecognitionException, TokenStreamException {
		Expr expr;
		
		
				expr = null;
				Expr lhs = null;
				Expr rhs = null;
				Op op = null;
			
		
		try {      // for error handling
			lhs=unary_expr();
			{
			switch ( LA(1)) {
			case STAR:
			case DIV:
			case MOD:
			{
				{
				switch ( LA(1)) {
				case STAR:
				{
					match(STAR);
					if ( inputState.guessing==0 ) {
						op = Op.MULTIPLY;
					}
					break;
				}
				case DIV:
				{
					match(DIV);
					if ( inputState.guessing==0 ) {
						op = Op.DIV;
					}
					break;
				}
				case MOD:
				{
					match(MOD);
					if ( inputState.guessing==0 ) {
						op = Op.MOD;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				rhs=unary_expr();
				break;
			}
			case RIGHT_PAREN:
			case RIGHT_BRACKET:
			case COMMA:
			case KW_OR:
			case KW_AND:
			case EQUALS:
			case NOT_EQUALS:
			case LT:
			case GT:
			case LTE:
			case GTE:
			case PLUS:
			case MINUS:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				
							expr = makeBinaryExpr(op, lhs, rhs);
						
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_22);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	public final Expr  unary_expr() throws RecognitionException, TokenStreamException {
		Expr expr;
		
		
				expr = null;
			
		
		try {      // for error handling
			switch ( LA(1)) {
			case SLASH:
			case DOUBLE_SLASH:
			case AT:
			case STAR:
			case IDENTIFIER:
			case LEFT_PAREN:
			case DOT:
			case DOT_DOT:
			case LITERAL:
			case NUMBER:
			case DOLLAR_SIGN:
			{
				expr=union_expr();
				break;
			}
			case MINUS:
			{
				match(MINUS);
				expr=unary_expr();
				if ( inputState.guessing==0 ) {
					
									expr = new NegativeExpr(expr);
								
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_23);
			} else {
			  throw ex;
			}
		}
		return expr;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"SLASH",
		"DOUBLE_SLASH",
		"AT",
		"STAR",
		"IDENTIFIER",
		"DOUBLE_COLON",
		"COLON",
		"LEFT_PAREN",
		"RIGHT_PAREN",
		"LEFT_BRACKET",
		"RIGHT_BRACKET",
		"DOT",
		"DOT_DOT",
		"LITERAL",
		"NUMBER",
		"DOLLAR_SIGN",
		"COMMA",
		"PIPE",
		"KW_OR",
		"KW_AND",
		"EQUALS",
		"NOT_EQUALS",
		"LT",
		"GT",
		"LTE",
		"GTE",
		"PLUS",
		"MINUS",
		"DIV",
		"MOD"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 17176744066L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 17178841218L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 98752L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 17178853298L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 17179867634L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { 17178852530L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	private static final long[] mk_tokenSet_7() {
		long[] data = { 17178850482L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
	private static final long[] mk_tokenSet_8() {
		long[] data = { 17178849458L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
	private static final long[] mk_tokenSet_9() {
		long[] data = { 17178841266L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
	private static final long[] mk_tokenSet_10() {
		long[] data = { 384L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_10 = new BitSet(mk_tokenSet_10());
	private static final long[] mk_tokenSet_11() {
		long[] data = { 16384L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_11 = new BitSet(mk_tokenSet_11());
	private static final long[] mk_tokenSet_12() {
		long[] data = { 1069056L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_12 = new BitSet(mk_tokenSet_12());
	private static final long[] mk_tokenSet_13() {
		long[] data = { 4096L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_13 = new BitSet(mk_tokenSet_13());
	private static final long[] mk_tokenSet_14() {
		long[] data = { 1052672L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_14 = new BitSet(mk_tokenSet_14());
	private static final long[] mk_tokenSet_15() {
		long[] data = { 98800L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_15 = new BitSet(mk_tokenSet_15());
	private static final long[] mk_tokenSet_16() {
		long[] data = { 17178951666L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_16 = new BitSet(mk_tokenSet_16());
	private static final long[] mk_tokenSet_17() {
		long[] data = { 919808L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_17 = new BitSet(mk_tokenSet_17());
	private static final long[] mk_tokenSet_18() {
		long[] data = { 5263360L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_18 = new BitSet(mk_tokenSet_18());
	private static final long[] mk_tokenSet_19() {
		long[] data = { 13651968L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_19 = new BitSet(mk_tokenSet_19());
	private static final long[] mk_tokenSet_20() {
		long[] data = { 63983616L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_20 = new BitSet(mk_tokenSet_20());
	private static final long[] mk_tokenSet_21() {
		long[] data = { 1070616576L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_21 = new BitSet(mk_tokenSet_21());
	private static final long[] mk_tokenSet_22() {
		long[] data = { 4291842048L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_22 = new BitSet(mk_tokenSet_22());
	private static final long[] mk_tokenSet_23() {
		long[] data = { 17176744064L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_23 = new BitSet(mk_tokenSet_23());
	
	}
